package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.ModuleDetailDTO;
import com.diagbot.dto.ModuleInfoDTO;
import com.diagbot.entity.ModuleDetail;
import com.diagbot.entity.ModuleInfo;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.service.impl.ModuleInfoServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.vo.ModuleVO;
import com.diagbot.vo.QuestionVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description: 模型业务层
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class ModuleFacade extends ModuleInfoServiceImpl {

    @Autowired
    ModuleDetailFacade moduleDetailFacade;
    @Autowired
    QuestionFacade questionFacade;

    /**
     * 返回所有的模型结构
     *
     * @return 模型结构
     */
    public List<ModuleInfoDTO> getAll(ModuleVO moduleVO) {
        List<ModuleInfoDTO> data = new ArrayList<>();
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("is_deleted", IsDeleteEnum.N.getKey());
        queryWrapper.orderByAsc("id");
        List<ModuleInfo> list = this.list(queryWrapper);
        data = BeanUtil.listCopyTo(list, ModuleInfoDTO.class);
        for (ModuleInfoDTO bean : data) {
            QueryWrapper wrapper = new QueryWrapper();
            wrapper.eq("is_deleted", IsDeleteEnum.N.getKey());
            wrapper.eq("module_id", bean.getId());
            wrapper.orderByAsc("order_no");
            List<ModuleDetail> moduleDetailList = moduleDetailFacade.list(wrapper);
            List<ModuleDetailDTO> moduleDetailDTOList = BeanUtil.listCopyTo(moduleDetailList, ModuleDetailDTO.class);
            bean.setModuleDetailDTOList(moduleDetailDTOList);
            for (ModuleDetailDTO detailDTO : moduleDetailDTOList) {
                if (null != detailDTO.getQuestionId()) {
                    QuestionVO questionVO = new QuestionVO();
                    questionVO.setId(detailDTO.getQuestionId());
                    questionVO.setSexType(moduleVO.getSexType());
                    questionVO.setAge(moduleVO.getAge());
                    detailDTO.setQuestionDTO(questionFacade.getById(questionVO));
                }
            }
        }
        return data;
    }

}
